<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>CarbonPHP Documentation</title>
	<style type="text/css">
		* {
			margin: 0;
			padding: 0;
		}

		html {
			font-family: "Lucida Sans Unicode", "Lucida Grande";
			font-size: 14px;
		}

		body {
			background: #fff;
			color: #666;
		}

		h1 {
			font-size: 15px;
			font-weight: bold;
			margin: 0 0 5px 0;
		}

		h2 {
			font-size: 13px;
			font-weight: bold;
			margin: 5px 0 5px 0;
		}

		ol, ul {
			margin: 10px 0 10px 0;
			list-style-position: inside;
		}

		p {
			margin: 5px 0 5px 0;
		}

		.content {
			border: 1px dotted #444;
			margin: 10px;
			padding: 10px;
			text-align: justify;
			width: 700px;
		}

		.example {
			border: 1px solid #ccc;
			background: #eee;
			margin: 10px;
			padding: 10px;
		}
	</style>
</head>

<body>
	<div class="content">
		<h1>Flickr API Library</h1>

		<p>The Flickr API library allows you to easily use the Flickr API.  You initialise the library using the
		following line and the object will be available as <b>$this->flickr</b>.</p>

		<div class="example">
			$this->load->library('flickr');
		</div>

		<p>You can also pass configuration parameters as an array in the second parameter of the method.</p>

		<div class="exmaple">
			$this->load->library('flickr', array('api_key' => 'yourapikeyhere', 'api_secret' => 'yourapisecrethere'));
		</div>
	</div>

	<div class="content">
		<h1>Calling a Flickr API Method</h1>

		<p>You can use the <b>$this->flickr->call_method()</b> method to call a Flickr API method.</p>
		
		<div class="example">
			$this->flickr->call_method('flickr.test.echo', array('foo' => 'bar', 'carbon' => 'php'));
		</div>

		<p>The above code will call the <b>flickr.test.echo</b> method and will return an XML response.  If the call fails
		the <b>$this->flickr->call_method()</b> will return -1, and you can call the following two methods to get the error code
		and message.</p>

		<div class="example">
			echo $this->flickr->get_error_code();<br />
			echo $this->flickr->get_error_message();</br />
		</div>

		<p>If the method call is successful you will get an XML representation in an object (simple XML).  You can then parse this
		reponse.  The reponse to our above method call will look something like the following response.</p>

		<div class="example">
			&lt;rsp stat="ok"&gt;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&lt;method&gt;flickr.test.echo&lt;/method&gt;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&lt;api_key&gt;apikeywillbehere&lt;/api_key&gt;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&lt;foo&gt;bar&lt;/foo&gt;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&lt;carbon&gt;php&lt;/carbon&gt;<br />
			&lt;/rsp&gt;	
		</div>
	</div>

	<div class="content">
		<h1>Calling Methods that Require Authentication</h1>

		<p>Some methods require that the user be authenticated to Flickr.  When you register your web application you
		can specify a callback URL that Flickr will redirect the user to once they are authenticated.  To create the URL the
		user must visit to authenticate the use of your web application is shown in the following code.</p>
		
		<div class="example">
			echo $this->flickr->get_auth_url('read');
		</div>

		<p>This will create an authentication URL that will grant your web application read permissions to the users
		Flickr profile.</p>

		<p>There are three permissions you can set they are shown below.</p>

		<ul>
			<li>read - grants the permission to read private information</li>
			<li>write - grants the permission to add, edit, delete photo metadata, this includes 'read'</li>
			<li>delete - grants the permission to delete photos, this includes 'write' and 'read'</li>
		</ul>

		<p>Once authenticated you can store the frob token, and use this to get a token to call the authenticated
		methods.</p>
	</div>
</body>

</html>
